pcl::ROPSEstimation< PointInT, PointOutT > Class Template Reference

This class implements the method for extracting RoPS features presented in the article "Rotational Projection Statistics for 3D Local Surface Description and Object Recognition" by Yulan Guo, Ferdous Sohel, Mohammed Bennamoun, Min Lu and Jianwei Wan. More...

`#include <pcl/features/rops_estimation.h>`

Inheritance diagram for pcl::ROPSEstimation< PointInT, PointOutT >:

## Public Types

typedef pcl::Feature< PointInT, PointOutT >::PointCloudOut | PointCloudOut
typedef pcl::Feature< PointInT, PointOutT >::PointCloudIn | PointCloudIn
Public Types inherited from pcl::Feature< PointInT, PointOutT >
typedef PCLBase< PointInT > | BaseClass
typedef boost::shared_ptr< Feature< PointInT, PointOutT > > | Ptr
typedef boost::shared_ptr< const Feature< PointInT, PointOutT > > | ConstPtr
typedef pcl::search::Search< PointInT > | KdTree
typedef pcl::search::Search< PointInT >::Ptr | KdTreePtr
typedef pcl::PointCloud< PointInT > | PointCloudIn
typedef PointCloudIn::Ptr | PointCloudInPtr
typedef PointCloudIn::ConstPtr | PointCloudInConstPtr
typedef pcl::PointCloud< PointOutT > | PointCloudOut
typedef boost::function< int(size_t, double, std::vector< int > &, std::vector< float > &)> | SearchMethod
typedef boost::function< int(const PointCloudIn &cloud, size_t index, double, std::vector< int > &, std::vector< float > &)> | SearchMethodSurface
Public Types inherited from pcl::PCLBase< PointInT >
typedef pcl::PointCloud< PointInT > | PointCloud
typedef PointCloud::Ptr | PointCloudPtr
typedef PointCloud::ConstPtr | PointCloudConstPtr
typedef boost::shared_ptr< PointIndices > | PointIndicesPtr
typedef boost::shared_ptr< PointIndices const > | PointIndicesConstPtr

## Public Member Functions

| ROPSEstimation ()
| Simple constructor. More...
virtual | ~ROPSEstimation ()
| Virtual destructor. More...
void | setNumberOfPartitionBins (unsigned int number_of_bins)
| Allows to set the number of partition bins that is used for distribution matrix calculation. More...
unsigned int | getNumberOfPartitionBins () const
| Returns the nmber of partition bins. More...
void | setNumberOfRotations (unsigned int number_of_rotations)
| This method sets the number of rotations. More...
unsigned int | getNumberOfRotations () const
| returns the number of rotations. More...
void | setSupportRadius (float support_radius)
| Allows to set the support radius that is used to crop the local surface of the point. More...
float | getSupportRadius () const
| Returns the support radius. More...
void | setTriangles (const std::vector< pcl::Vertices > &triangles)
| This method sets the triangles of the mesh. More...
void | getTriangles (std::vector< pcl::Vertices > &triangles) const
| Returns the triangles of the mesh. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
PointCloudConstPtr const | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (size_t row_start, size_t col_start, size_t nb_rows, size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
IndicesPtr const | getIndices ()
| Get a pointer to the vector of indices used. More...
IndicesConstPtr const | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointOutT>
class pcl::ROPSEstimation< PointInT, PointOutT >

This class implements the method for extracting RoPS features presented in the article "Rotational Projection Statistics for 3D Local Surface Description and Object Recognition" by Yulan Guo, Ferdous Sohel, Mohammed Bennamoun, Min Lu and Jianwei Wan.

Definition at line 55 of file rops_estimation.h.

## Member Typedef Documentation

template<typename PointInT , typename PointOutT >

typedef pcl::Feature<PointInT, PointOutT>::PointCloudIn pcl::ROPSEstimation< PointInT, PointOutT >::PointCloudIn

Definition at line 65 of file rops_estimation.h.

template<typename PointInT , typename PointOutT >

typedef pcl::Feature<PointInT, PointOutT>::PointCloudOut pcl::ROPSEstimation< PointInT, PointOutT >::PointCloudOut

Definition at line 64 of file rops_estimation.h.

## Constructor & Destructor Documentation

template<typename PointInT , typename PointOutT >

pcl::ROPSEstimation< PointInT, PointOutT >::ROPSEstimation | ( |  | ) |

Simple constructor.

Definition at line 47 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

pcl::ROPSEstimation< PointInT, PointOutT >::~ROPSEstimation | ( |  | ) |

virtual

Virtual destructor.

Definition at line 60 of file rops_estimation.hpp.

## Member Function Documentation

template<typename PointInT , typename PointOutT >

unsigned int pcl::ROPSEstimation< PointInT, PointOutT >::getNumberOfPartitionBins | ( |  | ) | const

Returns the nmber of partition bins.

Definition at line 76 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

unsigned int pcl::ROPSEstimation< PointInT, PointOutT >::getNumberOfRotations | ( |  | ) | const

returns the number of rotations.

Definition at line 94 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

float pcl::ROPSEstimation< PointInT, PointOutT >::getSupportRadius | ( |  | ) | const

Returns the support radius.

Definition at line 112 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

void pcl::ROPSEstimation< PointInT, PointOutT >::getTriangles | ( | std::vector< pcl::Vertices > & | triangles | ) | const

Returns the triangles of the mesh.

Parameters

  [out] | triangles | triangles of tthe mesh

Definition at line 126 of file rops_estimation.hpp.

References pcl::Feature< PointInT, PointOutT >::compute().

template<typename PointInT , typename PointOutT >

void pcl::ROPSEstimation< PointInT, PointOutT >::setNumberOfPartitionBins | ( | unsigned int | number_of_bins | ) |

Allows to set the number of partition bins that is used for distribution matrix calculation.

Parameters

  [in] | number_of_bins | number of partition bins

Definition at line 68 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

void pcl::ROPSEstimation< PointInT, PointOutT >::setNumberOfRotations | ( | unsigned int | number_of_rotations | ) |

This method sets the number of rotations.

Parameters

  [in] | number_of_rotations | number of rotations

Definition at line 83 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

void pcl::ROPSEstimation< PointInT, PointOutT >::setSupportRadius | ( | float | support_radius | ) |

Allows to set the support radius that is used to crop the local surface of the point.

Parameters

  [in] | support_radius | support radius

Definition at line 101 of file rops_estimation.hpp.

template<typename PointInT , typename PointOutT >

void pcl::ROPSEstimation< PointInT, PointOutT >::setTriangles | ( | const std::vector< pcl::Vertices > & | triangles | ) |

This method sets the triangles of the mesh.

Parameters

  [in] | triangles | list of triangles of the mesh

Definition at line 119 of file rops_estimation.hpp.

The documentation for this class was generated from the following files:

- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/rops_estimation.h
- /build/pcl-0nnAvv/pcl-1.7.2/features/include/pcl/features/impl/rops_estimation.hpp